#region New-CollectionFormatFile
function New-CollectionFormatFile
{

	$ffName = $PSScriptRoot + '\FormatData\PSCMX.Format.Collection.ps1xml'
	
	if (-not (Test-Path $ffName))
	{

		$templ = @"
<?xml version=`"1.0`" encoding=`"utf-8`" ?>
<Configuration>
    <ViewDefinitions>
        <View>
            <Name>SMS_Collection</Name>
            <ViewSelectedBy>
                <TypeName>System.Management.ManagementObject#root\sms\site_$($Script:CMProvider.SiteCode)\SMS_Collection</TypeName>
            </ViewSelectedBy>             
			<TableControl>
				<TableHeaders>
					<TableColumnHeader>
						<Label>CollectionID</Label>
						<Width>13</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>Name</Label>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>CurrentStatus</Label>
						<Width>18</Width>
					</TableColumnHeader>					
				</TableHeaders>
				<TableRowEntries>
					<TableRowEntry>
						<TableColumnItems>
							<TableColumnItem>
								<PropertyName>CollectionID</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>Name</PropertyName>
							</TableColumnItem>
							<TableColumnItem>								
								<ScriptBlock>
								switch (`$_.CurrentStatus)
								    {
								        0 {'None'}
								        1 {'Ready'}
								        2 {'Refreshing'}
								        3 {'Saving'}
								        4 {'Evaluating'}
								        5 {'Awaiting refresh'}
								        6 {'Deleting'}
								        7 {'Appending member'}
								        8 {'Querying'}
								    }
								</ScriptBlock>
							</TableColumnItem>
						</TableColumnItems>
					</TableRowEntry>
				</TableRowEntries>				
			</TableControl>
        </View>
	</ViewDefinitions>
</Configuration>

"@ | Out-File -FilePath $ffName -Force

		Update-FormatData -AppendPath $ffName -ErrorAction SilentlyContinue
	}
}
#endregion New-CollectionFormatFile

#region New-AdvertisementFormatFile
function New-AdvertisementFormatFile
{

	$ffName = $PSScriptRoot + '\FormatData\PSCMX.Format.Advertisement.ps1xml'
	
	if (-not (Test-Path $ffName))
	{

		$templ = @"
<?xml version=`"1.0`" encoding=`"utf-8`" ?>
<Configuration>
    <ViewDefinitions>
        <View>
            <Name>SMS_Advertisement</Name>
            <ViewSelectedBy>
                <TypeName>System.Management.ManagementObject#root\sms\site_$($Script:CMProvider.SiteCode)\SMS_Advertisement</TypeName>
            </ViewSelectedBy>             
			<TableControl>
				<TableHeaders>
					<TableColumnHeader>
						<Label>AdvertisementName</Label>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>ProgramName</Label>
						<Width>20</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>AdvertisementID</Label>
						<Width>17</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>PackageID</Label>
						<Width>10</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>CollectionID</Label>
						<Width>13</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>Expiry</Label>
						<Width>8</Width>
					</TableColumnHeader>
				</TableHeaders>
				<TableRowEntries>
					<TableRowEntry>
						<TableColumnItems>
							<TableColumnItem>
								<PropertyName>AdvertisementName</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>ProgramName</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>AdvertisementID</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>PackageID</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>CollectionID</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>ExpirationTimeEnabled</PropertyName>
							</TableColumnItem>
						</TableColumnItems>
					</TableRowEntry>
				</TableRowEntries>				
			</TableControl>
        </View>
	</ViewDefinitions>
</Configuration>

"@ | Out-File -FilePath $ffName -Force

		Update-FormatData -AppendPath $ffName -ErrorAction SilentlyContinue
	}
}
#endregion New-AdvertisementFormatFile

#region New-SiteFormatFile
function New-SiteFormatFile
{

	$ffName = $PSScriptRoot + '\FormatData\PSCMX.Format.Site.ps1xml'
	
	if (-not (Test-Path $ffName))
	{

		$templ = @"
<?xml version=`"1.0`" encoding=`"utf-8`" ?>
<Configuration>
    <ViewDefinitions>
        <View>
            <Name>SMS_Site</Name>
            <ViewSelectedBy>
                <TypeName>System.Management.ManagementObject#root\sms\site_$($Script:CMProvider.SiteCode)\SMS_Site</TypeName>
            </ViewSelectedBy>
			<TableControl>
				<TableHeaders>
					<TableColumnHeader>
						<Label>ServerName</Label>
						<Width>16</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>SiteCode</Label>
						<Width>10</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>ReportTo</Label>
						<Width>9</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>SiteName</Label>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>Version</Label>
						<Width>15</Width>
					</TableColumnHeader>
				</TableHeaders>
				<TableRowEntries>
					<TableRowEntry>
						<TableColumnItems>
							<TableColumnItem>
								<PropertyName>ServerName</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>SiteCode</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>ReportingSiteCode</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>SiteName</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>Version</PropertyName>
							</TableColumnItem>
						</TableColumnItems>
					</TableRowEntry>
				</TableRowEntries>				
			</TableControl>
        </View>
	</ViewDefinitions>
</Configuration>

"@ | Out-File -FilePath $ffName -Force

		Update-FormatData -AppendPath $ffName -ErrorAction SilentlyContinue
	}
}
#endregion New-SiteFormatFile

#region New-SystemResourceListFormatFile
function New-SystemResourceListFormatFile
{

	$ffName = $PSScriptRoot + '\FormatData\PSCMX.Format.SystemResourceList.ps1xml'
	
	if (-not (Test-Path $ffName))
	{

		$templ = @"
<?xml version=`"1.0`" encoding=`"utf-8`" ?>
<Configuration>
    <ViewDefinitions>
        <View>
            <Name>SMS_SystemResourceList</Name>
            <ViewSelectedBy>
                <TypeName>System.Management.ManagementObject#root\sms\site_$($Script:CMProvider.SiteCode)\SMS_SystemResourceList</TypeName>
            </ViewSelectedBy>
			<TableControl>
				<TableHeaders>
					<TableColumnHeader>
						<Label>ServerName</Label>
						<Width>16</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>SiteCode</Label>
						<Width>10</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>RoleName</Label>
						<Width>30</Width>
					</TableColumnHeader>
					<TableColumnHeader>
						<Label>NALPath</Label>
					</TableColumnHeader>
				</TableHeaders>
				<TableRowEntries>
					<TableRowEntry>
						<TableColumnItems>
							<TableColumnItem>
								<PropertyName>ServerName</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>SiteCode</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>RoleName</PropertyName>
							</TableColumnItem>
							<TableColumnItem>
								<PropertyName>NALPath</PropertyName>
							</TableColumnItem>
						</TableColumnItems>
					</TableRowEntry>
				</TableRowEntries>				
			</TableControl>
        </View>
	</ViewDefinitions>
</Configuration>

"@ | Out-File -FilePath $ffName -Force

		Update-FormatData -AppendPath $ffName -ErrorAction SilentlyContinue
	}
}
#endregion New-SystemResourceListFormatFile

#region Update-FormatFile
function Update-FormatFile
{
	param( $file )
	
	$f = (Get-Item $file).FullName
	Write-Verbose "Format file: $(Split-Path $f -Leaf)"
	
	$f -match '^.*\.(?<typename>.*?)\.ps1xml$' | Out-Null
	$typeName = $matches.TypeName
	Write-Verbose "  $typeName"
	
	$xml = [xml] (Get-Content $file)
	
	if (-not (Test-SiteCodeInTypeName $xml))
	{
		$element = "System.Management.ManagementObject#root\sms\site_$($Script:CMProvider).SiteCode)\$($Script:nameToClass[$typeName])"
		
		Write-Verbose "Element TypeName update: $element"
        $newElement = $xml.CreateElement('TypeName')
        $newElement.InnerText = $element
        [void] $xml.Configuration.ViewDefinitions.View.ViewSelectedBy.AppendChild($newElement)
        
		Write-Verbose "Saving updated version of $type format file."
        $xml.Save($f)
	}
	else
	{
		# Just for debuging
		Write-Verbose 'Site code already in format file.'
	}
}

#endregion Update-FormatFile

#region Test-SiteCodeInTypeName
function Test-SiteCodeInTypeName
{
	param ( $xml )
		
	$result = @()
	$result += foreach ($typeElement in $xml.Configuration.ViewDefinitions.View.ViewSelectedBy.TypeName)
    {
		Write-Verbose "Type element: $typeElement"
		$typeElement -match '^.*\\site_(?<SiteCode>\w{3})\\.*$' | Out-Null
		Write-Verbose "Site code found: $($matches.SiteCode)"
		$matches.SiteCode
    }
	
	($result -contains $($Script:CMProvider).SiteCode)    
}
#endregion Test-SiteCodeInTypeName